<template>
<div>
     <RoomCard
    v-if="type == 'list'"
    v-bind:kamer="kamer"
    :patient="patient"
    :alarmActief="checkAlarm"
      :backgroundColor="backgroundColor"
      :eerstVolgendeActie="eerstVolgendeActie"
      v-on:goToPatient="$emit('goToPatient',$event)"
      v-on:pushToArray="$emit('pushToArray',$event)"
    ></RoomCard>
 <RoomPlan
 v-if="type == 'map'"
      :kamer="kamer"
      :patient="patient"
      :alarmActief="checkAlarm"
      :eerstVolgendeActie="eerstVolgendeActie"
      :backgroundColor="backgroundColor"
      v-on:goToPatient="$emit('goToPatient',$event)"
      v-on:pushToArray="$emit('pushToArray',$event)"
    ></RoomPlan>
    </div>
</template>

<script>
import PatientService from '../services/PatientService'
import ActiesService from '../services/ActiesService'
import ErrorService from '../services/ErrorService'
import RoomPlan from './RoomPlan'
import RoomCard from './RoomCard'
import Utils from '../utils'
export default {
  name: 'AfdelingComponent',
  components: {
    RoomPlan, RoomCard
  },
  data () {
    return {
      patient: Object,
      eerstVolgendeActie: Object,
      type: this.Type,
      settings: this.$store.getters['settings/settings']
    }
  },
  props: {
    Type: String,
    kamer: Object,
    patientId: Number
  },
  methods: {
    async getPatient () {
      try {
        this.patient = await this.patientService.getById(this.patientId)
      } catch (error) {
        ErrorService.showAlert('Laden patiënt in notificatie mislukt')
      }
    },

    async getAction () {
      try {
        let array = await this.actiesService.getByPatientId(this.patientId)
        this.acties = array
        this.eerstVolgendeActie = Utils.getEerstVolgendeActie(array)
      } catch (error) {
        ErrorService.showAlert('Laden patiënt in notificatie mislukt')
      }
    }
  },
  created () {
    this.patientService = new PatientService()
    this.actiesService = new ActiesService()
    if (this.patientId !== null) {
      this.getPatient()
      this.getAction()
    } else {
      this.patient = null
    }
  },
  computed: {
    backgroundColor: function () {
      if (this.patient !== null) {
        return 'background-color: ' + this.settings.kleuren.bezet
      } else {
        return 'background-color: ' + this.settings.kleuren.vrij
      }
    },
    checkAlarm: function () {
      if (this.patient !== null) {
        if (this.patient.hartslag < this.settings.minHart || this.patient.hartslag > this.settings.maxHart) {
          return true
        } else if (this.patient.bloeddruk < this.settings.minBloed || this.patient.bloeddruk > this.settings.maxBloed) {
          return true
        } else {
          return false
        }
      }
      return false
    }
  }
}

</script>
